package pdv;

public class PDV {
  private CatalogoProdutos catalogoProdutos;
  private Venda venda;
  
  public CatalogoProdutos getCatalogoProdutos() {
    return catalogoProdutos;
  }
  
  public PDV(CatalogoProdutos catalogo) {
    catalogoProdutos = catalogo;
  }
  
  public void terminarVenda()
   throws IllegalStateException {
    if (venda != null) {
      if (venda.totalItens() > 0)
        venda.tornarseCompleta();
      else
        throw new IllegalStateException("A venda no possui itens");
    }
    else
      throw new IllegalStateException("A venda no existe");
  }
  
  public void entrarItem(int upc, int quantidade)
   throws IllegalArgumentException {
    if (quantidade > 0) {
      if (isNovaVenda())
        venda = new Venda();
      
      EspecificacaoProduto espec = catalogoProdutos.getEspecificacao(upc);
      
      if (espec != null)
        venda.construirLinhaItem(espec, quantidade);
      else
        throw new IllegalArgumentException("Cdigo do produto invlido");
    } 
    else {
      throw new IllegalArgumentException("Quantidade do produto invlida");
    }
  }

  public void registrarPagamento(float quantia)
   throws IllegalStateException, IllegalArgumentException {
    if (venda != null) {
      if (quantia >= venda.total())
        venda.efetuarPagamento(quantia);
      else
        throw new IllegalArgumentException("Quantia < total");
    }
    else
      throw new IllegalStateException("A venda no existe");      
  }
  
  public boolean isNovaVenda() {
    return (venda == null || venda.isCompleta());
  }

  public Venda getVenda() {
	  return venda;
  }
}
