package pdv;

import java.util.*;

public class Venda {
  private Vector linhaItens = new Vector();
  private Date data = new Date();
  private boolean isCompleta = false;
  private Pagamento pagamento;
  
  public float getTroco() {
    return pagamento.getQuantia() - total();
  }
  
  public void tornarseCompleta() {
    isCompleta = true;
  }
  
  public boolean isCompleta() {
    return isCompleta;
  }
  
  public void construirLinhaItem(EspecificacaoProduto espec, int quantidade) {
    linhaItens.addElement(new LinhaItemVenda(espec, quantidade));
  }
  
  public float total() {
    float total = 0;
    Enumeration e = linhaItens.elements();
    while (e.hasMoreElements()) {
      total += ((LinhaItemVenda)e.nextElement()).subtotal();
    }
    return total;
  }
  
  public int totalItens() {
    return linhaItens.size();
  }
  
  public void efetuarPagamento(float quantia) {
    pagamento = new Pagamento(quantia);
  }
}
